

maxIter = 100;
tolerance = 1e-12;

x = [100; 1000];

for iter = 1:maxIter
    fx = [
        x(1)^2/186^2 - x(2)^2/(300^2 - 186^2) - 1
        (x(2)-500)^2/279^2 - (x(1) - 300)^2/(500^2 - 279^2) - 1
    ];

    fprintf('Iteration #%d: residual norm %e\n', iter, norm(fx));
    if norm(fx) < tolerance
        break;
    end
    
    Jx = [
        2*x(1)/186^2                      -2*x(2)/(300^2 - 186^2)
        -2*(x(1) - 300)/(500^2 - 279^2)   2*(x(2)-500)/279^2
    ];
    
    x = x - Jx \ fx;
end

fprintf('Newton method converged after %d iterations to x = [%f, %f] (final residual %e)\n', iter, x, norm(fx));